local M = {}

local AutoGenAddon
if readFile("scripts/infoGenerator/infoGeneratorAutoGen.lua") then
	AutoGenAddon = require('scripts/infoGenerator/infoGeneratorAutoGen')
end
local json = require("json")

local function getPartConfigFilename()
	local partConfigFilename = extensions.core_vehicle_manager.getPlayerVehicleData().config.partConfigFilename
	if not partConfigFilename:match('vehicles/') then
		for _,path in pairs(FS:findFiles('vehicles/'..be:getPlayerVehicle(0):getJBeamFilename(), '*.pc', 0, true, true)) do
			if path:match(partConfigFilename..".pc") then
				partConfigFilename = path:sub(2)
				break
			end
		end
	end
	return partConfigFilename
end

local function Generate ()
	local unknown = '"unknown"'
	local BodyStyle = '""'
	local BrakingGMin = 0
	local BrakingGMax = 0
	local BrakingG = '""'
	local BrakingGFirst = 0
	local PopulationMin = 0
	local PopulationMax = 0
	local Population = '""'
	local PopulationFirst = 0
	local ValueSum = 0
	local YearsMaxMin = 0
	local YearsMaxMax = 0
	local YearsMinMin = 0
	local YearsMinMax = 0
	local YearsMax = 0
	local YearsMin = 0
	local YearsFirst = 0
	local br100kmhTo0Min = 0
	local br100kmhTo0Max = 0
	local br100kmhTo0 = '""'
	local br100kmhTo0First = 0
	local br60mphTo0Min = 0
	local br60mphTo0Max = 0
	local br60mphTo0 = '""'
	local br60mphTo0First = 0
	local OffRoadScoreMin = 0
	local OffRoadScoreMax = 0
	local OffRoadScore = '""'
	local OffRoadScoreFirst = 0
	local ConfigurationName = ''
	local vehNameFromInfo = ''
	local breakTest = 0
	local Description = ''
	local path = "temp/infoGenerator/checkbox2.json"
	local Add_technical_specifications_to_description = true

	if not AutoGenAddon then Description = 'Generated with \\"Info Generator\\"\\n' end
	if readFile(path) then
		local ok, data = pcall(json.decode, readFile(path))
		Add_technical_specifications_to_description = data.checked
	end

	local vehName = be:getPlayerVehicle(0):getJBeamFilename()
	local infoJson = '/vehicles/'..vehName..'/info.json'
	local default_pcCheck = 0
	if readFile(infoJson) then
		local ok, data = pcall(json.decode, readFile(infoJson))
		if data and data['Body Style'] then
			BodyStyle = '"'..data['Body Style']..'"'
		else print('"Not found Body Style"') BodyStyle = unknown
		end
		if data and data['Name'] then
			vehNameFromInfo = data['Name']
		end
		if data and data['default_pc'] then
			if data['default_pc']:lower():match('%.pc') and getPartConfigFilename():sub(10 + #vehName + 1):sub(0,-4):lower():match('%.pc') then
				default_pcCheck = 3
			end
		end
	else print('"Not found info.json"') BodyStyle = unknown
	end

	local FileName = getPartConfigFilename():sub(10 + #vehName + 1):sub(0,-4 - default_pcCheck)
	if #FileName == 0 then
		print('"Not found FileName"\n"ConfigurationName = vehNameFromInfo"')
		FileName = vehNameFromInfo
		while FileName:sub(#FileName) == ' ' do
			FileName = FileName:sub(0, -2)
			breakTest = breakTest + 1
			if breakTest > 10 then
				break
			end
		end
		ConfigurationName = '"'..FileName..'"'
	else
		for _,str in pairs(FileName:split("[^%_]+")) do
			if str:lower() ~= 'a' and str:lower() ~= 'm' and str:lower() ~= 'cvt' and str:lower() ~= 'dct' and str:lower() ~= 'sq' and str:lower() ~= 'sequential' then
				ConfigurationName = ConfigurationName..' '..str:sub(1,1):upper()..str:sub(2)
			end
		end
		ConfigurationName = '"'..ConfigurationName:sub(2)..'"'
	end

	local files = FS:findFiles('/vehicles/'..vehName, '*.json', 0, true, true)
	if files then
		for i = 1, #files do
			if (files[i] ~= '/vehicles/'..vehName..'/main.materials.json' and files[i] ~= '/vehicles/'..vehName..'/skin.materials.json') then
				local ok, data = pcall(json.decode, readFile(files[i]))
				if ok and data then
					if data['Braking G'] and tonumber(data['Braking G']) then
						if tonumber(data['Braking G']) > 0.1 then
							if BrakingGFirst == 0 then
								BrakingGMax = tonumber(data['Braking G'])
								BrakingGMin = tonumber(data['Braking G'])
								BrakingGFirst = 1
							end
							if tonumber(data['Braking G']) > BrakingGMax then
								BrakingGMax = tonumber(data['Braking G'])
							end
							if tonumber(data['Braking G']) < BrakingGMin then
								BrakingGMin = tonumber(data['Braking G'])
							end
						end
					end
					if data['Population'] and tonumber(data['Population']) and tonumber(data['Population']) > 0 then
						if tonumber(data['Population']) > 1 then
							if PopulationFirst == 0 then
								PopulationMax = tonumber(data['Population'])
								PopulationMin = tonumber(data['Population'])
								PopulationFirst = 1
							end
							if tonumber(data['Population']) > PopulationMax then
								PopulationMax = tonumber(data['Population'])
							end
							if tonumber(data['Population']) < PopulationMin then
								PopulationMin = tonumber(data['Population'])
							end
						end
					end
					if data['Years'] and data['Years']['max'] and data['Years']['min'] and tonumber(data['Years']['max']) and tonumber(data['Years']['min']) then
						if YearsFirst == 0 then
							YearsMaxMax = tonumber(data['Years']['max'])
							YearsMaxMin = tonumber(data['Years']['max'])
							YearsMinMax = tonumber(data['Years']['min'])
							YearsMinMin = tonumber(data['Years']['min'])
							YearsFirst = 1
						end
						if tonumber(data['Years']['max']) > YearsMaxMax then
							YearsMaxMax = tonumber(data['Years']['max'])
						end
						if tonumber(data['Years']['max']) < YearsMaxMin then
							YearsMaxMin = tonumber(data['Years']['max'])
						end
						if tonumber(data['Years']['min']) > YearsMinMax then
							YearsMinMax = tonumber(data['Years']['max'])
						end
						if tonumber(data['Years']['min']) < YearsMinMin then
							YearsMinMin = tonumber(data['Years']['max'])
						end
					end
					if data['100-0 km/h'] and tonumber(data['100-0 km/h']) and tonumber(data['100-0 km/h']) > 0 then
						if br100kmhTo0First == 0 then
							br100kmhTo0Max = tonumber(data['100-0 km/h'])
							br100kmhTo0Min = tonumber(data['100-0 km/h'])
							br100kmhTo0First = 1
						end
						if tonumber(data['100-0 km/h']) > br100kmhTo0Max then
							br100kmhTo0Max = tonumber(data['100-0 km/h'])
						end
						if tonumber(data['100-0 km/h']) < br100kmhTo0Min then
							br100kmhTo0Min = tonumber(data['100-0 km/h'])
						end
					end
					if data['60-0 mph'] and tonumber(data['60-0 mph']) and tonumber(data['60-0 mph']) > 0 then
						if br60mphTo0First == 0 then
							br60mphTo0Max = tonumber(data['60-0 mph'])
							br60mphTo0Min = tonumber(data['60-0 mph'])
							br60mphTo0First = 1
						end
						if tonumber(data['60-0 mph']) > br60mphTo0Max then
							br60mphTo0Max = tonumber(data['60-0 mph'])
						end
						if tonumber(data['60-0 mph']) < br60mphTo0Min then
							br60mphTo0Min = tonumber(data['60-0 mph'])
						end
					end
					if data['Off-Road Score'] and tonumber(data['Off-Road Score']) and tonumber(data['Off-Road Score']) > 0 then
						if data['Off-Road Score'] > 1 then
							if OffRoadScoreFirst == 0 then
								OffRoadScoreMax = tonumber(data['Off-Road Score'])
								OffRoadScoreMin = tonumber(data['Off-Road Score'])
								OffRoadScoreFirst = 1
							end
							if tonumber(data['Off-Road Score']) > OffRoadScoreMax then
								OffRoadScoreMax = tonumber(data['Off-Road Score'])
							end
							if tonumber(data['Off-Road Score']) < OffRoadScoreMin then
								OffRoadScoreMin = tonumber(data['Off-Road Score'])
							end
						end
					end
				end
			end
		end
	end
	if BrakingGMax == BrakingGMin then print('"No Braking G or info_ file found"') BrakingGMax = math.random(8, 12) / 10 BrakingGMin = math.random(4, 7) / 10 end
	BrakingG = '"'..tostring(math.ceil((math.random() * (BrakingGMax - BrakingGMin) + BrakingGMin) * 1000 - 0.5) / 1000)..'"'
	if PopulationMax == PopulationMin then print('"No Population or info_ file found"') PopulationMax = math.random(2500, 15000) PopulationMin = math.random(100, 500) end
	Population = '"'..tostring(math.ceil((math.random() * (PopulationMax - PopulationMin) + PopulationMin) / 10 - 0.5) * 10)..'"'
	if YearsMaxMax == 0 then print('"No Years or info_ file found"') YearsMaxMax,YearsMaxMin,YearsMinMax,YearsMinMin = 0,0,0,0 end
	if br100kmhTo0Max == br100kmhTo0Min then print('"No 100-0 km/h or info_ file found"') br100kmhTo0Max = math.random(425, 550) / 10 br100kmhTo0Min = math.random(250, 420) / 10 end
	br100kmhTo0 = '"'..tostring(math.ceil((math.random() * (br100kmhTo0Max - br100kmhTo0Min) + br100kmhTo0Min) * 10 - 0.5) / 10)..'"'
	if br60mphTo0Max == br60mphTo0Min then print('"No 60-0 mph or info_ file found"') br60mphTo0Max = math.random(425, 550) / 10 br60mphTo0Min = math.random(300, 420) / 10 end
	br60mphTo0 = '"'..tostring(math.ceil((math.random() * (br60mphTo0Max - br60mphTo0Min) + br60mphTo0Min) * 10 - 0.5) / 10)..'"'
	if OffRoadScoreMax == OffRoadScoreMin then print('"No Off-Road Score or info_ file found"') OffRoadScoreMax = math.random(41, 65) OffRoadScoreMin = math.random(30, 40) end
	OffRoadScore = '"'..tostring(math.ceil((math.random() * (OffRoadScoreMax - OffRoadScoreMin) + OffRoadScoreMin) - 0.5))..'"'

	breakTest = 0
	while YearsMax == YearsMin do
		YearsMax = math.random(YearsMaxMin,YearsMaxMax)
		YearsMin = math.random(YearsMinMin,YearsMinMax)
		breakTest = breakTest + 1
		if breakTest > 10 then
			break
		end
	end

	local chosenParts = extensions.core_vehicle_manager.getPlayerVehicleData()['vdata']['activeParts']
	if chosenParts then
		local EngineInstalled = ''
		local TransmissionInstalled = ''

		for partName, part in pairs(chosenParts) do
			if chosenParts[partName]['information'] and chosenParts[partName]['information']['value'] and tonumber(chosenParts[partName]['information']['value']) then
				ValueSum = ValueSum + tonumber(chosenParts[partName]['information']['value'])
			end
			if Add_technical_specifications_to_description then
				for name,Table in pairs(part) do
					if type(Table) == "table" then
						if Table['torqueReactionNodes:'] and Table.torque then
							EngineInstalled = EngineInstalled..'Engine installed - \\"'..part.information.name..'\\"\\n'
						end
						if part.enginetorque and Table.maxRPM then
							EngineInstalled = EngineInstalled..'Engine installed - \\"'..part.information.name..'\\"\\n'
						end
						if Table.gearRatios then
							TransmissionInstalled = TransmissionInstalled..'Transmission installed - \\"'..part.information.name..'\\"\\n'
						end
					end
				end
			end
		end

		Description = Description..EngineInstalled..TransmissionInstalled
	end

	ValueSum = '"'..tostring(math.abs(math.ceil(ValueSum / 5 / 100 - 0.5) * 100))..'"'

	if #BodyStyle - 2 > 11 then
		 be:executeJS(string.format('document.getElementById("BodyStyleInputInfoGen").value = %s', BodyStyle)..'; document.getElementById("BodyStyleInputInfoGen").style.fontSize = "14px"') --sbr
	else be:executeJS(string.format('document.getElementById("BodyStyleInputInfoGen").value = %s', BodyStyle))
	end
	be:executeJS(string.format('document.getElementById("BrakingGInputInfoGen").value = %s', BrakingG))
	be:executeJS(string.format('document.getElementById("ValueInputInfoGen").value = %s', ValueSum))
	be:executeJS(string.format('document.getElementById("PopulationInputInfoGen").value = %s', Population))
	be:executeJS(string.format('document.getElementById("YearsMaxInputInfoGen").value = %s', YearsMax))
	be:executeJS(string.format('document.getElementById("YearsMinInputInfoGen").value = %s', YearsMin))
	be:executeJS(string.format('document.getElementById("br100kmhTo0InputInfoGen").value = %s', br100kmhTo0))
	be:executeJS(string.format('document.getElementById("br60mphTo0InputInfoGen").value = %s', br60mphTo0))
	be:executeJS(string.format('document.getElementById("OffRoadScoreInputInfoGen").value = %s', OffRoadScore))
	be:executeJS(string.format('document.getElementById("ConfigurationNameInputInfoGen").value = %s', ConfigurationName))
	be:executeJS(string.format('document.getElementById("DescriptionInputInfoGen").value = %s', '"'..Description..'"'))

	be:getPlayerVehicle(0):queueLuaCommand([[
		local unknown = '"unknown"'
		local wheeltest = {}
		local wheelisPropulsed = {}
		local index = 0
		local test4WD = 0
		local Drivetrain = '""'
		local FuelType = '""'
		local Propulsion = '""'
		local Transmission = '""'
		local nodeWeightsum = 0
		local Power = '""'
		local Torque = '""'
		local WeightPower = '""'
		local PerfClass = '""'
		local TorquePeakRPM = '""'
		local PowerPeakRPM = '""'
		local zeroTo100kmh = '""'
		local zeroTo60mph = '""'
		local TopSpeed = '""'

		if powertrain.getDevices() then
			for name, Device in pairs(powertrain.getDevices()) do
				if (name == 'wheelaxleFR' or name == 'wheelaxleFL' or name == 'wheelaxleRR' or name == 'wheelaxleRL') then
					index = index + 1
					wheeltest[index] = name
					wheelisPropulsed[index] = Device.isPropulsed
				end
				if (name == 'axle1' or name == 'axle2' or name == 'axle3' or name == 'axle4') then
					Drivetrain = '"Other"'
					break
				end
				if (name == 'wheelaxle_FR' or name == 'wheelaxle_FL' or name == 'wheelaxle_RL1' or name == 'wheelaxle_RL2' or name == 'wheelaxle_RR1' or name == 'wheelaxle_RR2' or name == 'wheelaxle_R_RL1' or name == 'wheelaxle_R_RL2' or name == 'wheelaxle_R_RR1' or name == 'wheelaxle_R_RR2') then
					Drivetrain = '"Other"'
					break
				end
				if (name == 'mainMotor' or name == 'frontMotor' or name == 'rearMotor' or name == 'motor') then
					Drivetrain = '"Other"'
					break
				end
				if (Device.children and name ~= 'gearbox') then
					for _, idk in pairs(Device.children) do
						if idk.availableModes then
							if #idk.availableModes > 1 then
								if (name == 'transfercase' or name == 'halfshaftFL' or name == 'halfshaftFR') then
									test4WD = test4WD + 1
								end
							end
						end
					end
				end
			end

			for name, Device in pairs(powertrain.getDevices()) do
				if (name == 'mainMotor' or name == 'frontMotor' or name == 'rearMotor' or name == 'motor') then
					Transmission = '"Other"'
					FuelType = '"Battery"'
					break
				end
				if name == 'gearbox' then
					if Device.type then
						if Device.type == 'automaticGearbox' then
							Transmission = '"Automatic"'
						elseif Device.type == 'cvtGearbox' then
							Transmission = '"CVT"'
						elseif Device.type == 'dctGearbox' then
							Transmission = '"DCT"'
						elseif Device.type == 'manualGearbox' then
							Transmission = '"Manual"'
						elseif Device.type == 'sequentialGearbox' then
							Transmission = '"Sequential"'
						else
							Transmission = '"Other"'
						end
					else print('"Device.type not found"') Transmission = '"Other"'
					end
				end
			end
			if Transmission == '""' then Transmission = unknown end
		else print('"Powertrain not found"') Drivetrain = '"Other"' Transmission = '"Other"'
		end
		if Drivetrain ~= '"Other"' then
			local testF = 0
			local testR = 0
			for i = 1, index do
				if ((wheeltest[i] == 'wheelaxleFR' or wheeltest[i] == 'wheelaxleFL') and wheelisPropulsed[i]) then
					testF = testF + 1
				end
				if ((wheeltest[i] == 'wheelaxleRR' or wheeltest[i] == 'wheelaxleRL') and wheelisPropulsed[i]) then
					testR = testR + 1
				end
			end
			if (testF == 2 and testR == 0) then Drivetrain = '"FWD"' end
			if (testF == 0 and testR == 2) then Drivetrain = '"RWD"' end
			if (testF == 2 and testR == 2) then 
				if test4WD >= 1 then
					Drivetrain = '"4WD"'
				else Drivetrain = '"AWD"'
				end
			end
			if (testF > 0 and testF ~= 2) then print('"what"') Drivetrain = '"Other"' end
			if (testR > 0 and testR ~= 2) then print('"what"') Drivetrain = '"Other"' end
			if (testF == 0 and testR == 0) then print('"what"') Drivetrain = '"Other"' end
		end

		if FuelType == '""' then
			if energyStorage.getStorages() then 
				for _, Storage in pairs(energyStorage.getStorages()) do
					if Storage.energyType then
						if Storage.energyType ~= 'n2o' then
							if Storage.energyType == 'electricEnergy' then
								FuelType = '"Battery"'
								break
							elseif Storage.energyType == 'gasoline' then
								FuelType = '"Gasoline"'
								break
							elseif Storage.energyType == 'diesel' then
								FuelType = '"Diesel"'
								break
							elseif Storage.energyType == 'kerosene' then
								FuelType = '"Kerosene"'
								break
							else
								FuelType = '"Other"' --never
							end
						end
					else print('"EnergyType not found"') FuelType = unknown
					end
				end
				if FuelType == '""' then FuelType = unknown end
			else print('"EnergyStorage not found"') FuelType = unknown
			end
		end
		if (FuelType ~= unknown and FuelType ~= '"Other"') then if FuelType ~= '"Battery"' then Propulsion = '"ICE"' else Propulsion = '"Electric"' end else Propulsion = unknown end

		if v.data.nodes then
			for i = 0, tableSizeC(v.data.nodes) - 1 do
				nodeWeightsum = nodeWeightsum + obj:getNodeMass(v.data.nodes[i].cid)
			end
			nodeWeightsum = '"'..tostring(math.ceil(nodeWeightsum / 10) * 10)..'"'
		else print('"Nodes not found"') nodeWeightsum = unknown
		end

		local TorqueData
		if powertrain.getDevicesByCategory("engine")[1] then 
			TorqueData = powertrain.getDevicesByCategory("engine")[1]:getTorqueData()
		end
		if TorqueData then
			local maxRPM = TorqueData.maxRPM
			local maxTorque = TorqueData.maxTorque
			local maxPower = TorqueData.maxPower
			local maxTorqueRPM = TorqueData.maxTorqueRPM
			local maxPowerRPM = TorqueData.maxPowerRPM
			local curves = TorqueData.curves[TorqueData.finalCurveName]

			if maxPower then
				Power = '"'..tostring(math.abs(math.ceil(maxPower - 0.5)))..'"'
			else print('"maxPower not found"') Power = unknown
			end
			if maxTorque then
				Torque = '"'..tostring(math.abs(math.ceil(maxTorque / 10 - 0.5) * 10))..'"'
			else print('"maxTorque not found"') Torque = unknown
			end
			if (maxPower and nodeWeightsum ~= unknown) then
				WeightPower = '"'..tostring(math.ceil(tonumber(nodeWeightsum:sub(2,#nodeWeightsum-1)) / maxPower * 100 - 0.5) / 100)..'"'
			else print('"maxPower not found or Nodes not found"') WeightPower = unknown
			end
			if WeightPower ~= unknown then
				PerfClass = '"'..tostring(math.ceil(32 / tonumber(WeightPower:sub(2,#WeightPower-1))))..'"'
			else print('"Weight/Power not found"') PerfClass = unknown
			end

			if curves then
				local minRPMTorque = -1
				local maxRPMTorque = -1
				local minRPMPower = -1
				local maxRPMPower = -1

				for i = maxTorqueRPM, 0, -1 do
					local torque = curves.torque[i] or 0
					local relDifference = math.abs(torque - maxTorque) / maxTorque
					if relDifference > 0.02 then
						minRPMTorque = i
						break
					end
				end
				for i = maxTorqueRPM, maxRPM, 1 do
					local torque = curves.torque[i] or 0
					local relDifference = math.abs(torque - maxTorque) / maxTorque
					if relDifference > 0.02 then
						maxRPMTorque = i
						break
					end
				end

				for i = maxPowerRPM, 0, -1 do
					local power = curves.power[i] or 0
					local relDifference = math.abs(power - maxPower) / maxPower
					if relDifference > 0.02 then
						minRPMPower = i
						break
					end
				end
				for i = maxPowerRPM, maxRPM, 1 do
					local power = curves.power[i] or 0
					local relDifference = math.abs(power - maxPower) / maxPower
					if relDifference > 0.02 or i == maxRPM then
						maxRPMPower = i
						break
					end
				end

				local rpmRoundValue = 50
				if maxPower > 0 then
					maxPower = math.floor(maxPower)
					local powerMinRPM = math.ceil(minRPMPower / rpmRoundValue) * rpmRoundValue
					local powerMaxRPM = math.floor(maxRPMPower / rpmRoundValue) * rpmRoundValue
					local maxPowerRange = maxRPMPower - minRPMPower
					if maxPowerRange >= 50 then
						PowerPeakRPM = '"'..powerMinRPM..' - '..powerMaxRPM..'"'
					else PowerPeakRPM = '"'..powerMinRPM..'"'
					end
				else print('"Max power <= 0..."') PowerPeakRPM = unknown
				end
				if maxTorque > 0 then
					maxTorque = math.ceil(maxTorque / rpmRoundValue) * rpmRoundValue
					local torqueMinRPM = math.ceil(minRPMTorque / rpmRoundValue) * rpmRoundValue
					local torqueMaxRPM = math.ceil(maxRPMTorque / rpmRoundValue) * rpmRoundValue
					local maxTorqueRange = maxRPMTorque - minRPMTorque
					if maxTorqueRange >= 50 then
						TorquePeakRPM = '"'..torqueMinRPM..' - '..torqueMaxRPM..'"'
					else TorquePeakRPM = '"'..torqueMinRPM..'"'
					end
				else print('"Max torque <= 0..."') TorquePeakRPM = unknown
				end

				local Engine = powertrain.getDevicesByCategory("engine")[1]
				if Engine then
					local powerInIdleRPM = curves.power[Engine.idleRPM + 1]
					if not powerInIdleRPM then powerInIdleRPM = 0 end
					local powerInMaxRPM = curves.power[maxRPM]
					if powerInIdleRPM < 0 then powerInIdleRPM = 0 print('"powerInIdleRPM < 0, powerInIdleRPM = 0"') end
					if powerInMaxRPM < 0 then powerInMaxRPM = 0 print('"powerInMaxRPM < 0, powerInMaxRPM = 0"') end
					local torqueLossCoefSum = 0
					for name,device in pairs(powertrain.getDevices()) do
						if device.torqueLossCoef then
							torqueLossCoefSum = torqueLossCoefSum + device.torqueLossCoef
						end
					end
					if (Drivetrain == '"AWD"' or Drivetrain == '"4WD"') then torqueLossCoefSum = torqueLossCoefSum / 2 end
					if 1 - torqueLossCoefSum < 0 then print('"torqueLossCoefSum > 1, torqueLossCoefSum = 0"') torqueLossCoefSum = 0 end
					local AveragePower = (powerInIdleRPM + powerInMaxRPM) / 2
					local idk = 0
					if maxPower > 400 then idk = maxPower / 686 end

					if nodeWeightsum ~= unknown then
						zeroTo100kmh = '"'..math.ceil(((tonumber(nodeWeightsum:sub(2,#nodeWeightsum-1)) * ((100 / 3.6) ^ 2)) / (2 * AveragePower * 735.5 * (1 - torqueLossCoefSum)) + idk) * 10 - 0.5) / 10 ..'"'
						zeroTo60mph = '"'..math.ceil(((tonumber(nodeWeightsum:sub(2,#nodeWeightsum-1)) * ((60 / 2.237) ^ 2)) / (2 * AveragePower * 735.5 * (1 - torqueLossCoefSum)) + idk) * 10 - 0.5) / 10 ..'"'
					else
						print('"Weight = '..unknown..'"')
						zeroTo100kmh = unknown
						zeroTo60mph = unknown
					end
				else
					print('"Engine not found"')
					zeroTo100kmh = unknown
					zeroTo60mph = unknown
				end
			else 
				print('"Can\'t get torque curve for peak torque/power RPMs"')
				TorquePeakRPM = unknown
				PowerPeakRPM = unknown
				zeroTo100kmh = unknown
				zeroTo60mph = unknown
			end

			if v.data.wheels then
				local Width = 0
				local RatioOfHeightToWidth = 0
				local Diameter = 0
				local wheelSearch = ''
				local wheelSearchOth = ''
				local wheelSearchOth2 = ''
				if Drivetrain ~= '"FWD"' then
					wheelSearch = 'RL'
					wheelSearchOth = 'RL1'
					wheelSearchOth2 = 'RL_1'
				else
					wheelSearch = 'FL'
					wheelSearchOth = 'FL'
					wheelSearchOth2 = 'FL_1'
				end

				for id,wheel in pairs(v.data.wheels) do
					if wheel.name == wheelSearch or wheel.name == wheelSearchOth or wheel.name == wheelSearchOth2 then
						Width = math.max(wheel.tireWidth, wheel.hubWidth) * 1000
						Diameter = math.ceil(wheel.hubRadius / (25.4 / 1000) * 2 - 1 - 0.5)
						RatioOfHeightToWidth = math.ceil((math.ceil(wheel.radius * 2 / (25.4 / 1000) - 0.5) - Diameter) / 2 / (Width / 25.4) * 100 - 0.5)
						break
					end
				end

				local maxGRatio = 1
				if powertrain.getDevices().gearbox and powertrain.getDevices().gearbox.gearRatios then
					maxGRatio = powertrain.getDevices().gearbox.gearRatios[#powertrain.getDevices().gearbox.gearRatios]
				end
				local othRatioTemp = {}
				index = 0
				local othRatio = 1
				for name, Device in pairs(powertrain.getDevices()) do
					if name ~= 'rangebox' and name ~= 'gearbox' then
						if Device.gearRatio and Device.gearRatio ~= 0 and Device.gearRatio ~= 1 then
							index = index + 1 
							othRatioTemp[index] = Device.gearRatio
						end
					end
				end
				for i=1, index do
					for ii=1, index do
						if othRatioTemp[i] == othRatioTemp[ii] then
							if ii > i then othRatioTemp[ii] = 0 end
						end
					end
				end
				for i=1, index do
					if othRatioTemp[i] > 0 then
						othRatio = othRatio * othRatioTemp[i]
					end
				end

				TopSpeed = '"'..math.abs(math.ceil(maxRPM / maxGRatio / othRatio * math.pi * (Diameter * 25.4 + Width * RatioOfHeightToWidth / 100 * 2) / 1000000 * 60 / 3.6 - 0.5))..'"'
			else print('"Wheels not found"') TopSpeed = unknown
			end

		else 
			print('"TorqueData not found"')
			Power = unknown Torque = unknown
			WeightPower = unknown
			PerfClass = unknown
			TorquePeakRPM = unknown
			PowerPeakRPM = unknown
			zeroTo100kmh = unknown
			zeroTo60mph = unknown
			TopSpeed = unknown
		end
		
		local ConfigurationName = '""'
		if Transmission == '"Automatic"' then
			ConfigurationName = '" (A)"'
		elseif Transmission == '"Manual"' then
			ConfigurationName = '" (M)"'
		elseif Transmission == '"CVT"' then
			ConfigurationName = '" (CVT)"'
		elseif Transmission == '"DCT"' then
			ConfigurationName = '" (DCT)"'
		elseif Transmission == '"Sequential"' then
			ConfigurationName = '" (Sequential)"'
		end

		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("DrivetrainInputInfoGen").value = %s\')', Drivetrain))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("FuelTypeInputInfoGen").value = %s\')', FuelType))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("PropulsionInputInfoGen").value = %s\')', Propulsion))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("TransmissionInputInfoGen").value = %s\')', Transmission))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("WeightInputInfoGen").value = %s\')', nodeWeightsum))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("PowerInputInfoGen").value = %s\')', Power))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("TorqueInputInfoGen").value = %s\')', Torque))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("WeightPowerInputInfoGen").value = %s\')', WeightPower))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("PerfClassInputInfoGen").value = %s\')', PerfClass))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("PowerPeakRPMInputInfoGen").value = %s\')', PowerPeakRPM))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("TorquePeakRPMInputInfoGen").value = %s\')', TorquePeakRPM))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("zeroTo100kmhInputInfoGen").value = %s\')', zeroTo100kmh))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("zeroTo60mphInputInfoGen").value = %s\')', zeroTo60mph))
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("TopSpeedInputInfoGen").value = %s\')', TopSpeed))
		if ConfigurationName ~= '""' then
			obj:queueGameEngineLua(string.format('be:executeJS(\' if (!document.getElementById("ConfigurationNameInputInfoGen").value.match(/%s/)) document.getElementById("ConfigurationNameInputInfoGen").value += %s\')', ConfigurationName:sub(2,-2):gsub('[(]+','\\\\('):gsub('[)]+','\\\\)'), ConfigurationName))
		end

		local ConfigType = '"Custom"'
		if controller and controller.getAllControllers() and controller.getAllControllers().lightbar then
			ConfigType = '"Police"'
		end
		obj:queueGameEngineLua(string.format('be:executeJS(\'document.getElementById("ConfigTypeInputInfoGen").value = %s\')', ConfigType))
	]])
end

local function Create (str)
	local file
	local vehName = be:getPlayerVehicle(0):getJBeamFilename()
	local default_pcCheck = 0
	local infoJson = '/vehicles/'..vehName..'/info.json'
	local vehType = ''
	if readFile(infoJson) then
		local ok, data = pcall(json.decode, readFile(infoJson))
		if data and data['default_pc'] then
			if data['default_pc']:lower():match('%.pc') and getPartConfigFilename():sub(10 + #vehName + 1):sub(0,-4):lower():match('%.pc') then
				default_pcCheck = 3
			end
		end
		if data and data['Type'] then
			vehType = data['Type']
		end
	end
	local path
	local path2
	local fileExtension = {".png", ".jpg", ".tga", ".dds"}
	if not getPartConfigFilename():match('vehicles/') then
		print('".pc not found"\n".pc file will be created"')
		path = "vehicles/"..vehName.."/"..vehName..".pc"
		file = io.open(path, "W+")
		file:write('{\n"vars":{},\n"parts":{},\n"format":2\n}')
		file:close()
		path = "vehicles/"..vehName.."/info_"..vehName..".json"
		file = io.open(path, "W+")
		file:write(str)
		file:close()
		path = "vehicles/"..vehName.."/default"
		for i,ext in pairs(fileExtension) do
			if readFile(path..ext) then
				file = io.open("vehicles/"..vehName.."/"..vehName..ext, "W+")
				file:write(readFile(path..ext))
				file:close()
				break
			else if i == #fileExtension then print('"Default image not found"') end
			end
		end
	else
		path = "vehicles/"..vehName.."/info_"..getPartConfigFilename():sub(10 + #vehName + 1):sub(0,-4 - default_pcCheck)..".json"
		path2 = "temp/infoGenerator/"..path
		file = io.open(path, "W+")
		file:write(str)
		file:close()
		file = io.open(path2, "W+")
		file:write("\"For Replace mode :) \"")
		file:close()
		path = "vehicles/"..vehName.."/"..vehName
		
		if vehType == 'Automation' and not readFile(path..fileExtension[1]) then
			for i,ext in pairs(fileExtension) do
				if readFile(path..ext) then
					break
				else
					if i == #fileExtension then
						print('"'..vehName..' image not found"\n"image will be created"')
						path = "vehicles/"..vehName.."/default"
						for i2,ext2 in pairs(fileExtension) do
							if readFile(path..ext2) then
								file = io.open("vehicles/"..vehName.."/"..vehName..ext2, "W+")
								file:write(readFile(path..ext2))
								file:close()
								break
							else if i2 == #fileExtension then print('"Default image not found"') end
							end
						end
					end
				end
			end
		end
	end
end

local function AutoGenerationChecking ()
	if AutoGenAddon then
		AutoGenAddon.AutoGen()
	else
		be:executeJS([[
		setTimeout( () => {
			let elem = document.getElementById("AutoInfoGen");
			elem.textContent = "2.50$";
			elem.style.fontFamily = "Arial";
			elem.style.fontWeight = "bold";
			elem.style.color = "#000";
			window.location.href = "http-external://www.beamng.com/threads/info_-generator-mod.84510/"
		},50)
		]])
	end
end

local function StyleChangeChecking (action, borderColor, InputColor)
	if AutoGenAddon and action ~= "checkbox2" then
		AutoGenAddon.StyleChange(action, borderColor, InputColor)
	end
	if action == "checkbox2" then
		local path = "temp/infoGenerator/checkbox2.json"
		if readFile(path) then
			local ok, data = pcall(json.decode, readFile(path))
			be:executeJS(string.format([[
				setTimeout( () => {
					document.getElementById("checkbox_Add_technical_specifications_to_description").checked = %s
				}, 100)
			]], data.checked))
		end
	end
end

M.Generate = Generate
M.Create = Create
M.AutoGenerationChecking = AutoGenerationChecking
M.StyleChangeChecking = StyleChangeChecking
return M