angular.module('beamng.apps')
.directive('infoGenerator', ['$document', function ($document) {
  return {
  templateUrl: '/ui/modules/apps/infoGenerator/app.html',
  replace: true,
  link: function () {
	let All = [
		"ConfigurationNameInputInfoGen",
		"DescriptionInputInfoGen",
		"BodyStyleInputInfoGen",
		"DrivetrainInputInfoGen",
		"FuelTypeInputInfoGen",
		"TransmissionInputInfoGen",
		"WeightInputInfoGen",
		"ValueInputInfoGen",
		"PowerInputInfoGen",
		"WeightPowerInputInfoGen",
		"PowerPeakRPMInputInfoGen",
		"TorqueInputInfoGen",
		"PerfClassInputInfoGen",
		"TorquePeakRPMInputInfoGen",
		"BrakingGInputInfoGen",
		"PopulationInputInfoGen",
		"PropulsionInputInfoGen",
		"OffRoadScoreInputInfoGen",
		"TopSpeedInputInfoGen",
		"ConfigTypeInputInfoGen",
		"zeroTo100kmhInputInfoGen",
		"zeroTo60mphInputInfoGen",
		"br100kmhTo0InputInfoGen",
		"br60mphTo0InputInfoGen",
		"YearsMaxInputInfoGen",
		"YearsMinInputInfoGen"
	],
	AllInJson = [
		"  \\\"Configuration",
		"  \\\"Description",
		"  \\\"Body Style",
		"  \\\"Drivetrain",
		"  \\\"Fuel Type",
		"  \\\"Transmission",
		"  \\\"Weight",
		"  \\\"Value",
		"  \\\"Power",
		"  \\\"Weight/Power",
		"  \\\"PowerPeakRPM",
		"  \\\"Torque",
		"  \\\"Performance Class",
		"  \\\"TorquePeakRPM",
		"  \\\"Braking G",
		"  \\\"Population",
		"  \\\"Propulsion",
		"  \\\"Off-Road Score",
		"  \\\"Top Speed",
		"  \\\"Config Type",
		"  \\\"0-100 km/h",
		"  \\\"0-60 mph",
		"  \\\"100-0 km/h",
		"  \\\"60-0 mph",
		"  \\\"Years\\\":{\\\n    \\\"max",
		"    \\\"min"
	];
	$document.on('keydown', function(e){
		if (e.keyCode == 13) {
			for (index in All) {
				if (e.target.id != "DescriptionInputInfoGen"){
					if (e.target.id == All[index]) e.preventDefault()
				}
			}
		};
		if (e.keyCode == 8 && e.target.nodeName == "TEXTAREA") {
			for (index in All) {
				if (e.target.id == All[index]) {
					document.getElementById(All[index]).value = document.getElementById(All[index]).value.slice(0, -1)
				}
			}
		}
	});
	function Reset() {
		for (index in All) {document.getElementById(All[index]).value = ''};
	};
	Reset();
	bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Set")');
	bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("checkbox2")');
	bngApi.engineLua('FS:directoryRemove("temp/infoGenerator/vehicles/")');
	let InductionType = "NA";

	document.getElementById("GenerateInfoGen").addEventListener("click", function () {
		bngApi.engineLua('scripts_infoGenerator_infoGenerator.Generate()');
		setTimeout( () => {document.activeElement.blur()},100)
	});

	document.getElementById("CreateInfoGen").addEventListener("click", function () {
		if(
			document.getElementById("TopSpeedInputInfoGen").value.length < 1 ||
			document.getElementById("OffRoadScoreInputInfoGen").value.length < 1 ||
			document.getElementById("ConfigurationNameInputInfoGen").value.length < 1
		) {console.log("Error, not all fields are filled in")} else {
			let temp = '';
			temp += "{\\n";
			for (index in All) {
				let NumOrStr = '\\"',
				Comma = ',';
				if (All[index] != "PerfClassInputInfoGen" && All[index] != "DescriptionInputInfoGen" && (Number(document.getElementById(All[index]).value) || Number(document.getElementById(All[index]).value == 0))) NumOrStr = '';
				if (All[index] == "YearsMinInputInfoGen") Comma = '\\\n  },';
				temp += AllInJson[index] + '\\":' + NumOrStr + document.getElementById(All[index]).value.replace(/\\/g,'').replace(/"/g,'\\\\\\"').replace(/\n/g,'\\\\n') + NumOrStr + Comma + '\\n'
			};
			temp += "  \\\"Induction Type\\\":" + '\\"' + InductionType + '\\"\\n';
			temp += "}";
			bngApi.engineLua('scripts_infoGenerator_infoGenerator.Create(\"' + temp + '\")')
		};
		setTimeout( () => {document.activeElement.blur()},100)
	});

	document.getElementById("AutoInfoGen").addEventListener("click", function () {
		bngApi.engineLua('scripts_infoGenerator_infoGenerator.AutoGenerationChecking()');
		setTimeout( () => {document.activeElement.blur()},100)
	});

	document.getElementById("ClearInfoGen").addEventListener("click", function () {
		Reset();
		setTimeout( () => {document.activeElement.blur()},100)
	});

	let pressButton = false,
	pressButton2 = false,
	pressButtonTimer,
	pressButtonTimer2,
	animationTimer;

	document.getElementById("checkbox_Replace_files").disabled = true;

	document.getElementById("checkbox_Replace_files").onchange = function() {
		bngApi.engineLua(`
			local path = "temp/infoGenerator/checkbox.json"
			local file
			file = io.open(path, "W+")
			file:write("{\\n  \\"checked\\":`+document.getElementById("checkbox_Replace_files").checked+`\\n}")
			file:close()
			scripts_infoGenerator_infoGenerator.StyleChangeChecking("Set")
		`);
		setTimeout( () => {document.activeElement.blur()},100)
	};

	document.getElementById("checkbox_Add_technical_specifications_to_description").onchange = function() {
		bngApi.engineLua(`
			local path = "temp/infoGenerator/checkbox2.json"
			local file
			file = io.open(path, "W+")
			file:write("{\\n  \\"checked\\":`+document.getElementById("checkbox_Add_technical_specifications_to_description").checked+`\\n}")
			file:close()
		`);
		setTimeout( () => {document.activeElement.blur()},100)
	};

	document.getElementById("mainInfoGen").addEventListener("mousedown", function(e) {
		if(e.button === 0) {
			if (e.target.textContent == 'Clear') {
				pressButton = true;
				let scale = 0;
				animationTimer = setInterval( ()=> {
					scale += 0.32;
					if (scale > 30) {document.getElementById("ClearInfoGen").style.transform = 'scale(' + (scale - 29) + ')'}
				},10);
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Remove")');
					bngApi.engineLua('reloadUI()')
				}, 2500)
			};
			if (e.target.textContent == 'Auto Create' || e.target.textContent == '2.50$') {
				pressButton = true;
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#CC0", "#330")')
				}, 1000)
			};
			if (e.target.textContent == 'Create') {
				pressButton = true;
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#C60", "#420")')
				}, 1000)
			};
			if (e.target.textContent == 'Generate') {
				pressButton = true;
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#0C0", "#030")')
				}, 1000)
			};
			if (e.target.textContent == 'Clear') {
				pressButton2 = true;
				pressButtonTimer2 = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#C00", "#400")')
				}, 1000)
			}
		}
	});

	document.addEventListener('mouseup', function(e) {
		if (pressButton) {
			pressButton = false;
			clearTimeout(pressButtonTimer);
			clearInterval(animationTimer);
			document.getElementById("ClearInfoGen").style.transform = 'scale(' + 1 + ')';
			setTimeout( () => {document.activeElement.blur()},100)
		};

		if (pressButton2) {
			pressButton2 = false;
			clearTimeout(pressButtonTimer2);
			setTimeout( () => {document.activeElement.blur()},100)
		}
	});

	setTimeout( () => {if (vueI18n.global.locale == 'ru_RU') document.getElementById("AutorInfoGen").textContent = "Ns Pro"},1000)
  }}}]);